using System;
using System.Collections.Generic;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinTree;
using System.Drawing;

namespace DevscoveryPLFDemo
{
    class CustomNodeTextDrawingDrawFilter : IUIElementDrawFilter
    {
        #region IUIElementDrawFilter Members

        public Infragistics.Win.DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is NodeTextUIElement)
                return DrawPhase.BeforeDrawForeground;
            else
                return DrawPhase.None;
        }

        public bool DrawElement(Infragistics.Win.DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            // TODO:  Add Form1.DrawElement implementation
            UltraTreeNode treeNode = ((NodeTextUIElement)drawParams.Element).Node;
            if (treeNode != null)
            {
                string[] strings = treeNode.Text.Split('(');
                if (strings.Length == 2)
                {
                    RectangleF firstRect = (RectangleF)drawParams.Element.RectInsideBorders;
                    SolidBrush brush = new SolidBrush(Color.Black);
                    Font boldFont = new Font(drawParams.Font.FontFamily, drawParams.Font.Size, FontStyle.Bold);
                    drawParams.Graphics.DrawString(strings[0], boldFont, brush, firstRect);

                    float stringLeft = drawParams.Graphics.MeasureString(strings[0], boldFont).Width;

                    RectangleF secondRect = new RectangleF(firstRect.Left + stringLeft, firstRect.Y, firstRect.Width, firstRect.Height);
                    brush = new SolidBrush(Color.DarkGreen);
                    drawParams.Graphics.DrawString("(" + strings[1], drawParams.Font, brush, secondRect);

                    return true;
                }
            }
            return false;
        }

        #endregion
    }
}
