using System;
using System.Collections.Generic;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Drawing;

namespace DevscoveryPLFDemo
{
    class ExpandableGrouposCreationFilter : IUIElementCreationFilter
    {
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is HeaderUIElement)
            {
                HeaderUIElement helem = (HeaderUIElement)parent;
                if (helem.Header.Column == null && parent.ChildElements.Count < 2)
                {
                    ImageAndTextButtonUIElement eie = new ImageAndTextButtonUIElement(parent);

                    eie.Rect = new System.Drawing.Rectangle(parent.ChildElements[0].Rect.X, parent.ChildElements[0].Rect.Y, 16, 16);
                    eie.Image = Image.FromFile("exp.gif");
                    parent.ChildElements[0].Rect = new System.Drawing.Rectangle(parent.ChildElements[0].Rect.X + 20, parent.ChildElements[0].Rect.Y, parent.ChildElements[0].Rect.Width - 20, parent.ChildElements[0].Rect.Height);
                    eie.ElementClick += new UIElementEventHandler(eie_ElementClick);
                    parent.ChildElements.Insert(0, eie);
                }
            }
        }

        void eie_ElementClick(object sender, UIElementEventArgs e)
        {
            HeaderUIElement helem = (HeaderUIElement)e.Element.Parent;
            ImageAndTextButtonUIElement eie = (ImageAndTextButtonUIElement)e.Element;

            if (helem.Header.Group.Columns[1].Hidden)
            {
                eie.Image = Image.FromFile("exp.gif");

                for (int i = 1; i < helem.Header.Group.Columns.Count; i++)
                    helem.Header.Group.Columns[i].Hidden = false;
            }
            else
            {
                
                eie.Image = Image.FromFile("col.gif");
                
                for(int i = 1 ; i < helem.Header.Group.Columns.Count ; i++)
                    helem.Header.Group.Columns[i].Hidden = true;
            }
        }


        #endregion

        #region IUIElementCreationFilter Members


        public bool BeforeCreateChildElements(UIElement parent)
        {
            if (parent is HeaderUIElement)
            {
                HeaderUIElement helem = (HeaderUIElement)parent;
                if (helem.Header.Column == null && parent.ChildElements.Count == 2)
                    return true;
            }

            return false;
        }

        #endregion
    }
}
