using System;
using System.Collections.Generic;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Drawing;

namespace DevscoveryPLFDemo
{
    class RemoveGroupByExpansionIndicatorCreationFilter : IUIElementCreationFilter
    {
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {

        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            if (parent is GroupByRowExpansionIndicatorUIElement)
            {
                foreach (UIElement element in parent.Parent.ChildElements)
                {
                    GroupByRowDescriptionUIElement desc = element as GroupByRowDescriptionUIElement;
                    if (desc != null)
                    {
                        Rectangle orig = desc.RectInsideBorders;
                        Rectangle parentR = parent.RectInsideBorders;
                        desc.Rect = new Rectangle(parentR.Left, orig.Top, orig.Width + parentR.Width, orig.Height);
                        break;
                    }
                }
                parent.Parent.ChildElements.Remove(parent);
                parent.Dispose();
            }
            return false;
        }

        #endregion
    }
}
