using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinDataSource;

namespace DevscoveryLiveDataFeedDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            this.UpdateData();
        }

        private void UpdateData()
        {

            ArrayList ar = GetBunch();

            //ultraDataSource.Rows.Clear();
            //foreach (Object o in ar)
            //{
            //    Level2Data l2d = (Level2Data)o;
            //    object[] row = new object[4];
            //    row[0] = l2d._askInfo.MMID;
            //    row[1] = l2d._askInfo.lPrice;
            //    row[2] = l2d._askInfo.lSize;
            //    row[3] = DateTime.Now.ToString();

            //    ultraDataSource.Rows.Add(row);
            //}

            if (ar.Count > 0)
            {
                this.ProcessData(GetBunch());
            }
        }

        private void trackBar1_ValueChanged(object sender, EventArgs e)
        {
            this.timer1.Interval = this.trackBar1.Value;
        }

        #region Logic to get the dummy data i.e. Simulator code

        private ArrayList arrListAll = new ArrayList();

        Random rn = new Random();
        const int noOfMMID = 50;
        const int noOfSymbol = 5;

        static string[] arrMMID = new string[noOfMMID] { "BRUT", "ABC", "DEF", "IJK", "LMN", "OPQ", "RST", "UVW", "XYZ", "BRUT1", "ABC1", "DEF1", "IJK1", "LMN1", "OPQ1", "RST1", "UVW1", "XYZ1", "BRUT2", "ABC2", "DEF2", "IJK2", "LMN2", "OPQ2", "RST2", "UVW2", "XYZ2", "BRUT3", "ABC3", "DEF3", "IJK3", "LMN3", "OPQ3", "RST3", "UVW3", "XYZ3", "BRUT4", "ABC4", "DEF4", "IJK4", "LMN4", "OPQ4", "RST4", "UVW4", "XYZ4", "BRUT5", "ABC5", "DEF5", "IJK5", "LMN5" }; //,"OPQ5","RST5","UVW5","XYZ5"	};
        static string[] arrSymbol = new string[noOfSymbol] { "MSFT", "GOOG", "INFY", "IBM", "DELL" };
        static bool[] check = new bool[2] { true, false };

        Level2Data instLevel2Data = null;

        private string _symbol = "IBM";

        Hashtable HashBidMarketMakers = new Hashtable();
        Hashtable HashAskMarketMakers = new Hashtable();

        /// <summary>
        /// This is the main method, we are assigning the values to the UltraDatasource which
        /// is updating the grid eventually. Commenting is done line by line here whereever required.
        /// </summary>
        /// <param name="ar"></param>
        private void ProcessData(ArrayList ar)
        {
            short i;
            short numCount;

            //We can use this along with each entry but 
            //better way is to just compare this symbol with the associated grid's symbol
            numCount = Convert.ToInt16(ar.Count);

            // prevent ibindinglist notifications
            ultraDataSource.SuspendBindingNotifications();

            try
            {
                // get the graphics object for the grid
                Graphics g = this.ultraGrid1.CreateGraphics();


                // find the row col region intersection so
                // we can clip the rendering to this area
                UIElement intersection = this.ultraGrid1.DisplayLayout.UIElement.GetDescendant(typeof(RowColRegionIntersectionUIElement));

                if (intersection != null)
                {
                    // create an instance of the disposable drawcache class
                    // this is used to cache pens, brushes, etc. for the
                    // draw operations that will occur within this tick
                    // operation
                    using (DrawCache drawCache = new DrawCache(g, intersection, AlphaBlendMode.Optimized, false))
                    {
                        AppearanceData appearance = new AppearanceData();

                        // create a single UIElementDrawParams to use for all of the cell 
                        // rendering in this tick operation
                        UIElementDrawParams drawParams = new UIElementDrawParams(
                            intersection,
                            drawCache, intersection.Rect,
                            ref appearance, false, false, false);

                        // store a copy of the original region
                        // so we can restore the graphics object to
                        // its original state
                        using (Region oldRegion = g.Clip)
                        {
                            // clip such that the scrollbars, etc. are not
                            // part of the renderable area
                            g.IntersectClip(intersection.Rect);
                            Level2Data instLevel2Data = null;


                            for (i = 1; i <= numCount; i++)
                            {
                                //Data recived in the object instLevel2Data will be used to display on UI
                                instLevel2Data = (Level2Data)ar[i - 1];
                                if ((instLevel2Data._symbol.Trim().ToUpper() != this._symbol.Trim().ToUpper()) || (instLevel2Data._exchange.Trim().ToUpper() != "MONTAGE"))
                                    continue;

                                string _mmid = string.Empty;

                                ///We have 2 kind of data. Our simulator i.e. QuotesManager is throwing the 
                                ///data here every now and then. Either the instLevel2Data contains BidSide
                                ///or AskSide or both. 

                                #region BidSide record processing

                                int _rowBidToUpdate = int.MinValue;
                                //For Bid
                                ///Bid side data we need to display in the Grid called Bid. So checking the same.
                                if (instLevel2Data._isBidPresent)// && instLevel2Data.Symbol.Equals(_symbol) )
                                {
                                    MarketMakerRecord mmBid = instLevel2Data.BidInfo;
                                    _mmid = mmBid.MMID;

                                    lock (HashBidMarketMakers)
                                    {
                                        /// If the identifier _mmid exists in HashBidMarketMakers, then we will update on the row no _rowBidToUpdate 
                                        /// else we will set the _rowBidToUpdate as -1 and add the new row in table.
                                        if (HashBidMarketMakers.ContainsKey(_mmid))
                                        {
                                            _rowBidToUpdate = int.Parse(HashBidMarketMakers[_mmid].ToString());
                                        }
                                        else
                                        {
                                            _rowBidToUpdate = -1;
                                        }
                                    }

                                    UpdateBidRow(mmBid, _rowBidToUpdate, g, drawParams);
                                }

                                #endregion

                                #region AskSide record processing
                                int _rowAskToUpdate = int.MinValue;

                                ///This is to check the ask entry.
                                if (instLevel2Data._isAskPresent) // && instLevel2Data.Symbol.Equals(_symbol) ) 
                                {
                                    MarketMakerRecord mmAsk = instLevel2Data._askInfo;
                                    _mmid = mmAsk.MMID;

                                    lock (HashAskMarketMakers)
                                    {
                                        /// If the identifier _mmid exists in HashBidMarketMakers, then we will update on the row no _rowBidToUpdate 
                                        /// else we will set the _rowBidToUpdate as -1 and add the new row in table.
                                        if (HashAskMarketMakers.ContainsKey(_mmid))
                                        {
                                            _rowAskToUpdate = int.Parse(HashAskMarketMakers[_mmid].ToString());
                                        }
                                        else
                                        {
                                            _rowAskToUpdate = -1;
                                        }
                                    }
                                    UpdateAskRow(mmAsk, _rowAskToUpdate, g, drawParams);
                                }

                                #endregion
                            }

                        }
                    }
                }
                if (g != null)
                    g.Dispose();

                ultraDataSource.ResumeBindingNotifications(false);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Exception " + ex.Message + " " + ex.InnerException + " " + ex.StackTrace);
            }

        }

        /// <summary>
        /// This is specially to update the Bid Grid row - the left side UltraGrid
        /// </summary>
        /// <param name="mmBid"></param>
        /// <param name="rowBidToUpdate"></param>
        /// <param name="g"></param>
        /// <param name="drawParams"></param>
        private void UpdateBidRow(MarketMakerRecord mmBid, int rowBidToUpdate, Graphics g, UIElementDrawParams drawParams)
        {
            try
            {
                if (rowBidToUpdate != -1)
                {
                    ///update the row as the mmid already exist.
                    UltraDataRow ultraRow = ultraDataSource.Rows[rowBidToUpdate];
                    ultraRow["MMID"] = mmBid.MMID;
                    ultraRow["PRICE"] = mmBid.lPrice;
                    ultraRow["SIZE"] = mmBid.lSize;
                    ultraRow["TIME"] = mmBid.tTime.ToString();
                }
                else
                {
                    ///add the row as the mmid is new.
                    object[] row = new object[4];
                    row[0] = mmBid.MMID;
                    row[1] = mmBid.lPrice;
                    row[2] = mmBid.lSize;
                    row[3] = mmBid.tTime.ToString();

                    ultraDataSource.ResumeBindingNotifications();
                    ///Add the row into the datasource
                    UltraDataRow ultraRow = ultraDataSource.Rows.Add(row);
                    rowBidToUpdate = ultraRow.Index;
                    HashBidMarketMakers.Add(mmBid.MMID, rowBidToUpdate);
                    ultraDataSource.SuspendBindingNotifications();
                }

                if (g != null)
                {
                    // get the row associated with the change
                    UltraGridRow gridRow = this.ultraGrid1.Rows.GetRowWithListIndex(rowBidToUpdate);

                    if (gridRow == null) return;
                    UltraGridCell cell = null;

                    for (int col = 0; col < ultraDataSource.Band.Columns.Count; col++)
                    {
                        // get the cell that is changed
                        if (gridRow != null && gridRow.Cells != null)
                            cell = gridRow.Cells[col];

                        // find the cell in the active row/col scroll region
                        UIElement cellElement = cell.GetUIElement(this.ultraGrid1.ActiveRowScrollRegion, this.ultraGrid1.ActiveColScrollRegion, false);

                        if (cellElement != null)
                        {
                            // get the area within the borders of the cell
                            Rectangle rect = cellElement.RectInsideBorders;

                            // account for the overlapped borders (only
                            // happens with some borderstyles including the
                            // default solid borders)
                            rect.Width--;

                            // let the draw params know which element is being
                            // rendered and the invalid rect
                            drawParams.InitUIElement(cellElement, rect);

                            // draw the cell background
                            cellElement.DrawElement(ref drawParams);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Bid" + " " + mmBid.MMID + ex.Message + " " + ex.InnerException + " " + ex.StackTrace);
            }

        }

        /// <summary>
        /// This is specially to update the Ask Grid row - the right side UltraGrid
        /// </summary>
        /// <param name="mmAsk"></param>
        /// <param name="rowAskToUpdate"></param>
        /// <param name="g"></param>
        /// <param name="drawParams"></param>
        private void UpdateAskRow(MarketMakerRecord mmAsk, int rowAskToUpdate, Graphics g, UIElementDrawParams drawParams)
        {
            try
            {
                if (rowAskToUpdate != -1)
                {
                    UltraDataRow ultraRow = ultraDataSource.Rows[rowAskToUpdate];
                    ultraRow["MMID"] = mmAsk.MMID;
                    ultraRow["PRICE"] = mmAsk.lPrice;
                    ultraRow["SIZE"] = mmAsk.lSize;
                    ultraRow["TIME"] = mmAsk.tTime.ToString();
                }
                else
                {
                    object[] row = new object[4];
                    row[0] = mmAsk.MMID;
                    row[1] = mmAsk.lPrice;
                    row[2] = mmAsk.lSize;
                    row[3] = mmAsk.tTime.ToString();

                    ultraDataSource.ResumeBindingNotifications();
                    UltraDataRow ultraRow = ultraDataSource.Rows.Add(row);
                    rowAskToUpdate = ultraRow.Index;
                    HashAskMarketMakers.Add(mmAsk.MMID, rowAskToUpdate);
                    ultraDataSource.SuspendBindingNotifications();
                }

                if (g != null)
                {
                    // get the row associated with the change
                    UltraGridRow gridRow = this.ultraGrid1.Rows.GetRowWithListIndex(rowAskToUpdate);

                    if (gridRow == null) return;
                    UltraGridCell cell = null;

                    for (int col = 0; col < ultraDataSource.Band.Columns.Count; col++)
                    {
                        // get the cell that is changed
                        if (gridRow != null && gridRow.Cells != null)
                            cell = gridRow.Cells[col];

                        // find the cell in the active row/col scroll region
                        UIElement cellElement = cell.GetUIElement(this.ultraGrid1.ActiveRowScrollRegion, this.ultraGrid1.ActiveColScrollRegion, false);

                        if (cellElement != null)
                        {
                            // get the area within the borders of the cell
                            Rectangle rect = cellElement.RectInsideBorders;

                            // account for the overlapped borders (only
                            // happens with some borderstyles including the
                            // default solid borders)
                            rect.Width--;

                            // let the draw params know which element is being
                            // rendered and the invalid rect
                            drawParams.InitUIElement(cellElement, rect);

                            // draw the cell background
                            cellElement.DrawElement(ref drawParams);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Ask" + " " + mmAsk.MMID + ex.Message + " " + ex.InnerException + " " + ex.StackTrace);
            }
        }

        private ArrayList GetBunch()
        {
            //this will be the resposiblity of the e-Signal API
            int bunchCount = rn.Next(1, 100);
            ArrayList ar = new ArrayList();
            //ar = new ArrayList();
            for (int i = 0; i < bunchCount; i++)
            {
                ar.Add(getLevel2Data());
            }
            return ar;
        }

        private Level2Data getLevel2Data()
        {
            instLevel2Data = new Level2Data();

            //Todo : Search for symbol	
            instLevel2Data._mmid = arrMMID[rn.Next(0, noOfMMID)];
            instLevel2Data._symbol = arrSymbol[rn.Next(0, noOfSymbol - 1)];
            instLevel2Data._exchange = "Montage";

            int nextindex = rn.Next(2);
            if (check[nextindex] == true)
            {
                MarketMakerRecord mmBid = new MarketMakerRecord();
                mmBid.MMID = instLevel2Data._mmid;
                mmBid.lPrice = rn.Next(-50, 50) * 0.1;
                mmBid.lSize = rn.Next(0, 3000);
                mmBid.tTime = DateTime.Now.ToString();

                instLevel2Data.BidInfo = mmBid;
                instLevel2Data._isBidPresent = true;
            }

            nextindex = rn.Next(2);
            if (check[nextindex] == true)
            {
                MarketMakerRecord mmAsk = new MarketMakerRecord();
                mmAsk.MMID = instLevel2Data._mmid;
                mmAsk.lPrice = rn.Next(-50, 50) * 0.1;
                mmAsk.lSize = rn.Next(0, 3000);
                mmAsk.tTime = DateTime.Now.ToString();

                instLevel2Data._askInfo = mmAsk;
                instLevel2Data._isAskPresent = true;
            }

            return instLevel2Data;
        }

        #endregion Logic to get the dummy data i.e. Simulator code
    }
}