using System.Diagnostics;
using Microsoft.VisualBasic;
using System;
using System.Data;
using System.Collections;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace Project.Support
{
	//****************************************************************
	//****************************************************************
	//** Class:          SerializationTool
	//** Author:         Tommaso Puglisi
	//** Date:           February 06, 2004
	//****************************************************************
	//****************************************************************
	
	
	public sealed class SerializationTool
	{
		
		//****************************************************************
		//****************************************************************
		//** Private Constructor
		//****************************************************************
		//****************************************************************
		public SerializationTool() {
			//Cannot Instantiate
		}
		
		//****************************************************************
		//****************************************************************
		//** Recieves Object And Path + File Name To Persist Object
		//****************************************************************
		//****************************************************************
		public static bool SerializeObject(object ObjectInstance, string FilePath)
		{
			FileStream oFs = null;
			BinaryFormatter oBf;
			bool bVal;
			
			try
			{
				oFs = File.Create(FilePath);
				
				oBf = new BinaryFormatter();
				
				oBf.Serialize(oFs, ObjectInstance);
				
				bVal = true;
				
			}
			catch (Exception objException)
			{
				bVal = false;
				throw (objException);
			}
			finally
			{
				oFs.Close();
				oBf = null;
			}
			
			return bVal;
			
		}
		
		//****************************************************************
		//****************************************************************
		//** Returns Object That Has Been Deserialized
		//****************************************************************
		//****************************************************************
		public static object DeserializeObject(string FilePath)
		{
			FileStream oFs;
			BinaryFormatter oBf;
			object oBj = null;
			
			try
			{
				if (File.Exists(FilePath))
				{
					oFs = File.Open(FilePath, FileMode.Open);
					
					oBf = new BinaryFormatter();
					
					oBj = oBf.Deserialize(oFs);
					
					oFs.Close();
					
					oBf = null;
				}
				
			}
			catch (Exception objException)
			{
				throw (objException);
			}
			finally
			{
				//No Code For Now
			}
			
			return oBj;
			
		}
		
	}
	
}
