using System.Diagnostics;
using Microsoft.VisualBasic;
using System;
using System.Data;
using System.Collections;
using System.Windows.Forms;

namespace Project.Support
{
	//'' -----------------------------------------------------------------------------
	//'' Project	 : Project.Config
	//'' Class	 : Config.Global
	//''
	//'' -----------------------------------------------------------------------------
	//'' <summary>
	//'' Shared Class that wraps the ApplicationSettings class and returns Values
	//'' to the Main application.
	//'' Any information that can be user configured must be placed in
	//'' ApplicationSettings and called by this class. Any static values can
	//'' be hard coded as a property of this class.
	//'' </summary>
	//'' <remarks>
	//'' </remarks>
	//'' <history>
	//'' 	[ntense99]	11/23/2004	Created
	//'' </history>
	//'' -----------------------------------------------------------------------------
	
	public sealed class Config
	{
		public Config() {
		}
		public static string MainCN
		{
			get{
				ApplicationSettings a = SettingsTool.GetSettings();
				
				return "data source=" + a.DbDataSource + ";" + "initial catalog=" + a.DbDatabase + ";" + "User ID=" + a.DbLogin + ";" + "Password=" + a.DbPassword + ";";
			}
		}
		public static string AppSettingsFile
		{
			get{
				return Application.StartupPath + "\\_APPSETTINGS.DAT";
			}
		}
		public static string DockSettingsFile
		{
			get{
				return Application.StartupPath + "\\_DOCKSETTINGS.DAT";
			}
		}
		public static string ToolbarMainSettingsFile
		{
			get{
				return Application.StartupPath + "\\_TOOLBARMAINSETTINGS.DAT";
			}
		}
		public static string ChartSettingsFile(string ReportID)
		{
			return Application.StartupPath + "\\" + ReportID + "_CHARTSETTINGS.XML";
		}
		public static string GridSettingsFile(string ReportID)
		{
			return Application.StartupPath + "\\" + ReportID + "_GRIDSETTINGS.XML";
		}
		public static string ErrorLog
		{
			get{
				return Application.StartupPath + "\\_ERRORLOG.TXT";
			}
		}
	}
	
}
