using System.Diagnostics;
using Microsoft.VisualBasic;
using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Collections;
using Infragistics.Win;
using Infragistics.Win.UltraWinTree;
using Infragistics.Win.UltraWinGrid;

namespace Project.UI
{
	
	public class UIElementManager
	{
		public UIElementManager() {
		}
		
		public static Infragistics.Win.UltraWinTree.UltraTreeNode GetTreeNodeFromMousePosition(Infragistics.Win.UltraWinTree.UltraTree theTree)
		{
			Infragistics.Win.UIElement objElementClicked;
			Infragistics.Win.UltraWinTree.UltraTreeNode objNode = null;
			
			objElementClicked = theTree.UIElement.ElementFromPoint(theTree.PointToClient(Form.MousePosition));
			
			if (objElementClicked != null)
			{
				
                System.Diagnostics.Debug.WriteLine("objElementClicked: " + objElementClicked.ToString());
				
				if (objElementClicked is Infragistics.Win.UltraWinTree.NodeTextUIElement || objElementClicked is Infragistics.Win.ImageUIElement)
				{
					objNode = ((Infragistics.Win.UltraWinTree.UltraTreeNode)(objElementClicked.GetContext(typeof(Infragistics.Win.UltraWinTree.UltraTreeNode))));
				}
			}
			return objNode;
		}
		
		public static UltraGridRow GetGridRowFromMousePosition(UltraGrid theGrid)
		{
			Infragistics.Win.UIElement objElementClicked;
			Infragistics.Win.UIElement objRowElement;
			
			UltraGridRow objRow = null;
			
			objElementClicked = theGrid.DisplayLayout.UIElement.ElementFromPoint(theGrid.PointToClient(Form.MousePosition));
			
			if (!Convert.ToBoolean( objElementClicked == null))
			{
				
System.Diagnostics.Debug.WriteLine("objElementClicked: " + objElementClicked.ToString());
				objRowElement = objElementClicked.GetAncestor(typeof(Infragistics.Win.UltraWinGrid.RowUIElement));
				
				if (!(objRowElement == null))
				{
					objRow = ((UltraGridRow)(objRowElement.GetContext(typeof(Infragistics.Win.UltraWinGrid.UltraGridRow))));
				}
			}
			return objRow;
		}
		
	}
	
}
